<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaseDTOSearchCriteria StructType
 * @subpackage Structs
 */
abstract class BaseDTOSearchCriteria extends AbstractStructBase
{
    /**
     * The ids
     * Meta information extracted from the WSDL
     * - arrayType: xsd:long[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var int[]
     */
    public $ids;
    /**
     * The pageNumber
     * @var int
     */
    public $pageNumber;
    /**
     * The results
     * Meta information extracted from the WSDL
     * - arrayType: xsd:anyType[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var mixed[]
     */
    public $results;
    /**
     * Constructor method for BaseDTOSearchCriteria
     * @uses BaseDTOSearchCriteria::setIds()
     * @uses BaseDTOSearchCriteria::setPageNumber()
     * @uses BaseDTOSearchCriteria::setResults()
     * @param int[] $ids
     * @param int $pageNumber
     * @param mixed[] $results
     */
    public function __construct(array $ids = array(), $pageNumber = null, array $results = array())
    {
        $this
            ->setIds($ids)
            ->setPageNumber($pageNumber)
            ->setResults($results);
    }
    /**
     * Get ids value
     * @return int[]|null
     */
    public function getIds()
    {
        return $this->ids;
    }
    /**
     * This method is responsible for validating the values passed to the setIds method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIds method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdsForArrayConstraintsFromSetIds(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $baseDTOSearchCriteriaIdsItem) {
            // validation for constraint: itemType
            if (!(is_int($baseDTOSearchCriteriaIdsItem) || ctype_digit($baseDTOSearchCriteriaIdsItem))) {
                $invalidValues[] = is_object($baseDTOSearchCriteriaIdsItem) ? get_class($baseDTOSearchCriteriaIdsItem) : sprintf('%s(%s)', gettype($baseDTOSearchCriteriaIdsItem), var_export($baseDTOSearchCriteriaIdsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ids property can only contain items of type long, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ids value
     * @throws \InvalidArgumentException
     * @param int[] $ids
     * @return \StructType\BaseDTOSearchCriteria
     */
    public function setIds(array $ids = array())
    {
        // validation for constraint: array
        if ('' !== ($idsArrayErrorMessage = self::validateIdsForArrayConstraintsFromSetIds($ids))) {
            throw new \InvalidArgumentException($idsArrayErrorMessage, __LINE__);
        }
        $this->ids = $ids;
        return $this;
    }
    /**
     * Add item to ids value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\BaseDTOSearchCriteria
     */
    public function addToIds($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The ids property can only contain items of type long, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ids[] = $item;
        return $this;
    }
    /**
     * Get pageNumber value
     * @return int|null
     */
    public function getPageNumber()
    {
        return $this->pageNumber;
    }
    /**
     * Set pageNumber value
     * @param int $pageNumber
     * @return \StructType\BaseDTOSearchCriteria
     */
    public function setPageNumber($pageNumber = null)
    {
        // validation for constraint: int
        if (!is_null($pageNumber) && !(is_int($pageNumber) || ctype_digit($pageNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pageNumber, true), gettype($pageNumber)), __LINE__);
        }
        $this->pageNumber = $pageNumber;
        return $this;
    }
    /**
     * Get results value
     * @return mixed[]|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * This method is responsible for validating the values passed to the setResults method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResults method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResultsForArrayConstraintsFromSetResults(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $baseDTOSearchCriteriaResultsItem) {
            // validation for constraint: itemType
            if (false) {
                $invalidValues[] = is_object($baseDTOSearchCriteriaResultsItem) ? get_class($baseDTOSearchCriteriaResultsItem) : sprintf('%s(%s)', gettype($baseDTOSearchCriteriaResultsItem), var_export($baseDTOSearchCriteriaResultsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The results property can only contain items of type anyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set results value
     * @throws \InvalidArgumentException
     * @param mixed[] $results
     * @return \StructType\BaseDTOSearchCriteria
     */
    public function setResults(array $results = array())
    {
        // validation for constraint: array
        if ('' !== ($resultsArrayErrorMessage = self::validateResultsForArrayConstraintsFromSetResults($results))) {
            throw new \InvalidArgumentException($resultsArrayErrorMessage, __LINE__);
        }
        $this->results = $results;
        return $this;
    }
    /**
     * Add item to results value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\BaseDTOSearchCriteria
     */
    public function addToResults($item)
    {
        // validation for constraint: itemType
        if (false) {
            throw new \InvalidArgumentException(sprintf('The results property can only contain items of type anyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->results[] = $item;
        return $this;
    }
}
