<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomField StructType
 * @subpackage Structs
 */
class CustomField extends PWObject
{
    /**
     * The dataType
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dataType;
    /**
     * The definitionID
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $definitionID;
    /**
     * The fieldName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $fieldName;
    /**
     * The value
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $value;
    /**
     * Constructor method for CustomField
     * @uses CustomField::setDataType()
     * @uses CustomField::setDefinitionID()
     * @uses CustomField::setFieldName()
     * @uses CustomField::setValue()
     * @param string $dataType
     * @param int $definitionID
     * @param string $fieldName
     * @param string $value
     */
    public function __construct($dataType = null, $definitionID = null, $fieldName = null, $value = null)
    {
        $this
            ->setDataType($dataType)
            ->setDefinitionID($definitionID)
            ->setFieldName($fieldName)
            ->setValue($value);
    }
    /**
     * Get dataType value
     * @return string|null
     */
    public function getDataType()
    {
        return $this->dataType;
    }
    /**
     * Set dataType value
     * @param string $dataType
     * @return \StructType\CustomField
     */
    public function setDataType($dataType = null)
    {
        // validation for constraint: string
        if (!is_null($dataType) && !is_string($dataType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataType, true), gettype($dataType)), __LINE__);
        }
        $this->dataType = $dataType;
        return $this;
    }
    /**
     * Get definitionID value
     * @return int|null
     */
    public function getDefinitionID()
    {
        return $this->definitionID;
    }
    /**
     * Set definitionID value
     * @param int $definitionID
     * @return \StructType\CustomField
     */
    public function setDefinitionID($definitionID = null)
    {
        // validation for constraint: int
        if (!is_null($definitionID) && !(is_int($definitionID) || ctype_digit($definitionID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($definitionID, true), gettype($definitionID)), __LINE__);
        }
        $this->definitionID = $definitionID;
        return $this;
    }
    /**
     * Get fieldName value
     * @return string|null
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }
    /**
     * Set fieldName value
     * @param string $fieldName
     * @return \StructType\CustomField
     */
    public function setFieldName($fieldName = null)
    {
        // validation for constraint: string
        if (!is_null($fieldName) && !is_string($fieldName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fieldName, true), gettype($fieldName)), __LINE__);
        }
        $this->fieldName = $fieldName;
        return $this;
    }
    /**
     * Get value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param string $value
     * @return \StructType\CustomField
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->value = $value;
        return $this;
    }
}
