<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Nsf StructType
 * @subpackage Structs
 */
class Nsf extends PWFinanceObject
{
    /**
     * The bankAccount
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $bankAccount;
    /**
     * The payer
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $payer;
    /**
     * The refNo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $refNo;
    /**
     * Constructor method for Nsf
     * @uses Nsf::setBankAccount()
     * @uses Nsf::setPayer()
     * @uses Nsf::setRefNo()
     * @param string $bankAccount
     * @param string $payer
     * @param string $refNo
     */
    public function __construct($bankAccount = null, $payer = null, $refNo = null)
    {
        $this
            ->setBankAccount($bankAccount)
            ->setPayer($payer)
            ->setRefNo($refNo);
    }
    /**
     * Get bankAccount value
     * @return string|null
     */
    public function getBankAccount()
    {
        return $this->bankAccount;
    }
    /**
     * Set bankAccount value
     * @param string $bankAccount
     * @return \StructType\Nsf
     */
    public function setBankAccount($bankAccount = null)
    {
        // validation for constraint: string
        if (!is_null($bankAccount) && !is_string($bankAccount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bankAccount, true), gettype($bankAccount)), __LINE__);
        }
        $this->bankAccount = $bankAccount;
        return $this;
    }
    /**
     * Get payer value
     * @return string|null
     */
    public function getPayer()
    {
        return $this->payer;
    }
    /**
     * Set payer value
     * @param string $payer
     * @return \StructType\Nsf
     */
    public function setPayer($payer = null)
    {
        // validation for constraint: string
        if (!is_null($payer) && !is_string($payer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($payer, true), gettype($payer)), __LINE__);
        }
        $this->payer = $payer;
        return $this;
    }
    /**
     * Get refNo value
     * @return string|null
     */
    public function getRefNo()
    {
        return $this->refNo;
    }
    /**
     * Set refNo value
     * @param string $refNo
     * @return \StructType\Nsf
     */
    public function setRefNo($refNo = null)
    {
        // validation for constraint: string
        if (!is_null($refNo) && !is_string($refNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refNo, true), gettype($refNo)), __LINE__);
        }
        $this->refNo = $refNo;
        return $this;
    }
}
